## mdadm 3.3

=== Makefile ===
#
# mdadm - manage Linux "md" devices aka RAID arrays.
#
# Copyright (C) 2001-2002 Neil Brown <neilb@cse.unsw.edu.au>
# Copyright (C) 2013 Neil Brown <neilb@suse.de>
#
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Author: Neil Brown
#    Email: <neilb@cse.unsw.edu.au>
#    Paper: Neil Brown
#           School of Computer Science and Engineering
#           The University of New South Wales
#           Sydney, 2052
#           Australia
#

# define "CXFLAGS" to give extra flags to CC.
# e.g.  make CXFLAGS=-O to optimise
TCC = tcc
UCLIBC_GCC = $(shell for nm in i386-uclibc-linux-gcc i386-uclibc-gcc; do which $$nm > /dev/null && { echo $$nm ; exit; } ; done; echo false No uclibc found )
#DIET_GCC = diet gcc
# sorry, but diet-libc doesn't know about posix_memalign,
# so we cannot use it any more.
DIET_GCC = gcc -DHAVE_STDINT_H

KLIBC=/home/src/klibc/klibc-0.77

KLIBC_GCC = gcc -nostdinc -iwithprefix include -I$(KLIBC)/klibc/include -I$(KLIBC)/linux/include -I$(KLIBC)/klibc/arch/i386/include -I$(KLIBC)/klibc/include/bits32

CC = $(CROSS_COMPILE)gcc
CXFLAGS ?= -ggdb
CWFLAGS = -Wall -Werror -Wstrict-prototypes -Wextra -Wno-unused-parameter
ifdef WARN_UNUSED
CWFLAGS += -Wp,-D_FORTIFY_SOURCE=2 -O3
endif

ifdef DEBIAN
CPPFLAGS += -DDEBIAN
endif
ifdef DEFAULT_OLD_METADATA
 CPPFLAGS += -DDEFAULT_OLD_METADATA
 DEFAULT_METADATA=0.90
else
 DEFAULT_METADATA=1.2
endif

PKG_CONFIG ?= pkg-config

SYSCONFDIR = /etc
CONFFILE = $(SYSCONFDIR)/mdadm.conf
CONFFILE2 = $(SYSCONFDIR)/mdadm/mdadm.conf
MAILCMD =/usr/sbin/sendmail -t
CONFFILEFLAGS = -DCONFFILE=\"$(CONFFILE)\" -DCONFFILE2=\"$(CONFFILE2)\"
# Both MAP_DIR and MDMON_DIR should be somewhere that persists across the
# pivotroot from early boot to late boot.
# /run is best, but for distros that don't support that.
# /dev can work, in which case you probably want /dev/.mdadm
RUN_DIR=/run/mdadm
CHECK_RUN_DIR=1
MAP_DIR=$(RUN_DIR)
MAP_FILE = map
MAP_PATH = $(MAP_DIR)/$(MAP_FILE)
MDMON_DIR = $(RUN_DIR)
# place for autoreplace cookies
FAILED_SLOTS_DIR = $(RUN_DIR)/failed-slots
SYSTEMD_DIR=/lib/systemd/system
DIRFLAGS = -DMAP_DIR=\"$(MAP_DIR)\" -DMAP_FILE=\"$(MAP_FILE)\"
DIRFLAGS += -DMDMON_DIR=\"$(MDMON_DIR)\"
DIRFLAGS += -DFAILED_SLOTS_DIR=\"$(FAILED_SLOTS_DIR)\"
CFLAGS = $(CWFLAGS) $(CXFLAGS) -DSendmail=\""$(MAILCMD)"\" $(CONFFILEFLAGS) $(DIRFLAGS)

VERSION = $(shell [ -d .git ] && git describe HEAD | sed 's/mdadm-//')
VERS_DATE = $(shell [ -d .git ] && date --date="`git log -n1 --format=format:%cd --date=short`" '+%0dth %B %Y' | sed -e 's/1th/1st/' -e 's/2th/2nd/' -e 's/11st/11th/' -e 's/12nd/12th/')
DVERS = $(if $(VERSION),-DVERSION=\"$(VERSION)\",)
DDATE = $(if $(VERS_DATE),-DVERS_DATE="\"$(VERS_DATE)\"",)
CFLAGS += $(DVERS) $(DDATE)

# The glibc TLS ABI requires applications that call clone(2) to set up
# TLS data structures, use pthreads until mdmon implements this support
USE_PTHREADS = 1
ifdef USE_PTHREADS
CFLAGS += -DUSE_PTHREADS
MON_LDFLAGS += -pthread
endif

# If you want a static binary, you might uncomment these
# LDFLAGS = -static
# STRIP = -s

INSTALL = /usr/bin/install
DESTDIR =
BINDIR  = /sbin
MANDIR  = /usr/share/man
MAN4DIR = $(MANDIR)/man4
MAN5DIR = $(MANDIR)/man5
MAN8DIR = $(MANDIR)/man8

UDEVDIR := $(shell $(PKG_CONFIG) --variable=udevdir udev 2>/dev/null)
ifndef UDEVDIR
 UDEVDIR = /lib/udev
endif

OBJS =  mdadm.o config.o policy.o mdstat.o  ReadMe.o util.o maps.o lib.o \
	Manage.o Assemble.o Build.o \
	Create.o Detail.o Examine.o Grow.o Monitor.o dlink.o Kill.o Query.o \
	Incremental.o Dump.o \
	mdopen.o super0.o super1.o super-ddf.o super-intel.o bitmap.o \
	super-mbr.o super-gpt.o \
	restripe.o sysfs.o sha1.o mapfile.o crc32.o sg_io.o msg.o xmalloc.o \
	platform-intel.o probe_roms.o

CHECK_OBJS = restripe.o sysfs.o maps.o lib.o xmalloc.o dlink.o

SRCS =  $(patsubst %.o,%.c,$(OBJS))

INCL = mdadm.h part.h bitmap.h

MON_OBJS = mdmon.o monitor.o managemon.o util.o maps.o mdstat.o sysfs.o \
	policy.o lib.o \
	Kill.o sg_io.o dlink.o ReadMe.o super0.o super1.o super-intel.o \
	super-mbr.o super-gpt.o \
	super-ddf.o sha1.o crc32.o msg.o bitmap.o xmalloc.o \
	platform-intel.o probe_roms.o

MON_SRCS = $(patsubst %.o,%.c,$(MON_OBJS))

STATICSRC = pwgr.c
STATICOBJS = pwgr.o

ASSEMBLE_SRCS := mdassemble.c Assemble.c Manage.c config.c policy.c dlink.c util.c \
	maps.c lib.c xmalloc.c \
	super0.c super1.c super-ddf.c super-intel.c sha1.c crc32.c sg_io.c mdstat.c \
	platform-intel.c probe_roms.c sysfs.c super-mbr.c super-gpt.c
ASSEMBLE_AUTO_SRCS := mdopen.c
ASSEMBLE_FLAGS:= $(CFLAGS) -DMDASSEMBLE
ifdef MDASSEMBLE_AUTO
ASSEMBLE_SRCS += $(ASSEMBLE_AUTO_SRCS)
ASSEMBLE_FLAGS += -DMDASSEMBLE_AUTO
endif

all : check_rundir mdadm mdmon
man : mdadm.man md.man mdadm.conf.man mdmon.man raid6check.man

check_rundir:
	@if [ ! -d "$(dir $(RUN_DIR))" -a  "$(CHECK_RUN_DIR)" == 1 ]; then \
		echo "***** Parent of $(RUN_DIR) does not exist.  Maybe set different RUN_DIR="; \
		echo "*****  e.g. make RUN_DIR=/dev/.mdadm" ; \
		echo "***** or set CHECK_RUN_DIR=0"; exit 1; \
	fi

everything: all mdadm.static swap_super test_stripe raid6check \
	mdassemble mdassemble.auto mdassemble.static mdassemble.man \
	mdadm.Os mdadm.O2 man
everything-test: all mdadm.static swap_super test_stripe \
	mdassemble.auto mdassemble.static mdassemble.man \
	mdadm.Os mdadm.O2 man
# mdadm.uclibc and mdassemble.uclibc don't work on x86-64
# mdadm.tcc doesn't work..

mdadm : check_rundir $(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o mdadm $(OBJS) $(LDLIBS)

mdadm.static : $(OBJS) $(STATICOBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -static -o mdadm.static $(OBJS) $(STATICOBJS)

mdadm.tcc : $(SRCS) $(INCL)
	$(TCC) -o mdadm.tcc $(SRCS)

mdadm.klibc : $(SRCS) $(INCL)
	rm -f $(OBJS)
	$(CC) -nostdinc -iwithprefix include -I$(KLIBC)/klibc/include -I$(KLIBC)/linux/include -I$(KLIBC)/klibc/arch/i386/include -I$(KLIBC)/klibc/include/bits32 $(CFLAGS) $(SRCS)

mdadm.Os : $(SRCS) $(INCL)
	$(CC) -o mdadm.Os $(CFLAGS) $(LDFLAGS) -DHAVE_STDINT_H -Os $(SRCS)

mdadm.O2 : $(SRCS) $(INCL) mdmon.O2
	$(CC) -o mdadm.O2 $(CFLAGS) $(LDFLAGS) -DHAVE_STDINT_H -O2 -D_FORTIFY_SOURCE=2 $(SRCS)

mdmon.O2 : $(MON_SRCS) $(INCL) mdmon.h
	$(CC) -o mdmon.O2 $(CFLAGS) $(LDFLAGS) $(MON_LDFLAGS) -DHAVE_STDINT_H -O2 -D_FORTIFY_SOURCE=2 $(MON_SRCS)

# use '-z now' to guarantee no dynamic linker interactions with the monitor thread
mdmon : check_rundir $(MON_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(MON_LDFLAGS) -Wl,-z,now -o mdmon $(MON_OBJS) $(LDLIBS)
msg.o: msg.c msg.h

test_stripe : restripe.c xmalloc.o mdadm.h
	$(CC) $(CXFLAGS) $(LDFLAGS) -o test_stripe xmalloc.o  -DMAIN restripe.c

raid6check : raid6check.o mdadm.h $(CHECK_OBJS)
	$(CC) $(CXFLAGS) $(LDFLAGS) -o raid6check raid6check.o $(CHECK_OBJS)

mdassemble : $(ASSEMBLE_SRCS) $(INCL)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $(ASSEMBLE_FLAGS) -o mdassemble $(ASSEMBLE_SRCS)  $(STATICSRC)

mdassemble.diet : $(ASSEMBLE_SRCS) $(INCL)
	rm -f $(OBJS)
	$(DIET_GCC) $(ASSEMBLE_FLAGS) -o mdassemble $(ASSEMBLE_SRCS)  $(STATICSRC)

mdassemble.static : $(ASSEMBLE_SRCS) $(INCL)
	rm -f $(OBJS)
	$(CC) $(LDFLAGS) $(ASSEMBLE_FLAGS) -static -DHAVE_STDINT_H -o mdassemble.static $(ASSEMBLE_SRCS) $(STATICSRC)

mdassemble.auto : $(ASSEMBLE_SRCS) $(INCL) $(ASSEMBLE_AUTO_SRCS)
	rm -f mdassemble.static
	$(MAKE) MDASSEMBLE_AUTO=1 mdassemble.static
	mv mdassemble.static mdassemble.auto

mdassemble.uclibc : $(ASSEMBLE_SRCS) $(INCL)
	rm -f $(OJS)
	$(UCLIBC_GCC) $(ASSEMBLE_FLAGS) -DUCLIBC -DHAVE_STDINT_H -static -o mdassemble.uclibc $(ASSEMBLE_SRCS) $(STATICSRC)

# This doesn't work
mdassemble.klibc : $(ASSEMBLE_SRCS) $(INCL)
	rm -f $(OBJS)
	$(KLIBC_GCC) $(ASSEMBLE_FLAGS) -o mdassemble $(ASSEMBLE_SRCS)

mdadm.8 : mdadm.8.in
	sed -e 's/{DEFAULT_METADATA}/$(DEFAULT_METADATA)/g' \
	-e 's,{MAP_PATH},$(MAP_PATH),g'  mdadm.8.in > mdadm.8

mdadm.man : mdadm.8
	nroff -man mdadm.8 > mdadm.man

mdmon.man : mdmon.8
	nroff -man mdmon.8 > mdmon.man

md.man : md.4
	nroff -man md.4 > md.man

mdadm.conf.man : mdadm.conf.5
	nroff -man mdadm.conf.5 > mdadm.conf.man

mdassemble.man : mdassemble.8
	nroff -man mdassemble.8 > mdassemble.man

raid6check.man : raid6check.8
	nroff -man raid6check.8 > raid6check.man

$(OBJS) : $(INCL) mdmon.h
$(MON_OBJS) : $(INCL) mdmon.h

sha1.o : sha1.c sha1.h md5.h
	$(CC) $(CFLAGS) -DHAVE_STDINT_H -o sha1.o -c sha1.c

install : mdadm mdmon install-man install-udev
	$(INSTALL) -D $(STRIP) -m 755 mdadm $(DESTDIR)$(BINDIR)/mdadm
	$(INSTALL) -D $(STRIP) -m 755 mdmon $(DESTDIR)$(BINDIR)/mdmon

install-static : mdadm.static install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.static $(DESTDIR)$(BINDIR)/mdadm

install-tcc : mdadm.tcc install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.tcc $(DESTDIR)$(BINDIR)/mdadm

install-uclibc : mdadm.uclibc install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.uclibc $(DESTDIR)$(BINDIR)/mdadm

install-klibc : mdadm.klibc install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.klibc $(DESTDIR)$(BINDIR)/mdadm

install-man: mdadm.8 md.4 mdadm.conf.5 mdmon.8
	$(INSTALL) -D -m 644 mdadm.8 $(DESTDIR)$(MAN8DIR)/mdadm.8
	$(INSTALL) -D -m 644 mdmon.8 $(DESTDIR)$(MAN8DIR)/mdmon.8
	$(INSTALL) -D -m 644 md.4 $(DESTDIR)$(MAN4DIR)/md.4
	$(INSTALL) -D -m 644 mdadm.conf.5 $(DESTDIR)$(MAN5DIR)/mdadm.conf.5

install-udev: udev-md-raid-arrays.rules udev-md-raid-assembly.rules
	$(INSTALL) -D -m 644 udev-md-raid-arrays.rules $(DESTDIR)$(UDEVDIR)/rules.d/63-md-raid-arrays.rules
	$(INSTALL) -D -m 644 udev-md-raid-assembly.rules $(DESTDIR)$(UDEVDIR)/rules.d/64-md-raid-assembly.rules

install-systemd: systemd/mdmon@.service
	$(INSTALL) -D -m 644 systemd/mdmon@.service $(DESTDIR)$(SYSTEMD_DIR)/mdmon@.service

uninstall:
	rm -f $(DESTDIR)$(MAN8DIR)/mdadm.8 $(DESTDIR)$(MAN8DIR)/mdmon.8 $(DESTDIR)$(MAN4DIR)/md.4 $(DESTDIR)$(MAN5DIR)/mdadm.conf.5 $(DESTDIR)$(BINDIR)/mdadm

test: mdadm mdmon test_stripe swap_super raid6check
	@echo "Please run './test' as root"

clean :
	rm -f mdadm mdmon $(OBJS) $(MON_OBJS) $(STATICOBJS) core *.man \
	mdadm.tcc mdadm.uclibc mdadm.static *.orig *.porig *.rej *.alt .merge_file_* \
	mdadm.Os mdadm.O2 mdmon.O2 \
	mdassemble mdassemble.static mdassemble.auto mdassemble.uclibc \
	mdassemble.klibc swap_super \
	init.cpio.gz mdadm.uclibc.static test_stripe raid6check raid6check.o mdmon \
	mdadm.8

dist : clean
	./makedist

testdist : everything-test clean
	./makedist test

TAGS :
	etags *.h *.c

DISTRO_MAKEFILE := $(wildcard distropkg/Makefile)
ifdef DISTRO_MAKEFILE
include $(DISTRO_MAKEFILE)
endif

=== debian/changelog ===
mdadm (3.3-2ubuntu7) xenial; urgency=medium

  * Do not start when inside a container (LP: #1568993)

 -- Simon Deziel <simon.deziel@gmail.com>  Mon, 11 Apr 2016 18:33:45 +0000

mdadm (3.3-2ubuntu6) xenial; urgency=medium

  * debian/cotrol: Drop MTA Recommends to a Suggests (LP #1549319)

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 24 Mar 2016 16:39:13 -0600

mdadm (3.3-2ubuntu5) xenial; urgency=medium

  * Drop grub override, and thus use mdadm to assemble ISMS and DDF raids.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 19 Feb 2016 17:27:12 +0000

mdadm (3.3-2ubuntu4) xenial; urgency=low

  * debian/control: recommend kmod in preference to module-init-tools.

 -- Andy Whitcroft <apw@ubuntu.com>  Wed, 17 Feb 2016 11:43:15 +0000

mdadm (3.3-2ubuntu3) xenial; urgency=medium

  * debian/mdadm.init: Stop depending on mdadm-raid, as we removed that init
    script in Ubuntu in favor of udev rules.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Fri, 11 Dec 2015 10:03:17 +0100

mdadm (3.3-2ubuntu2) wily; urgency=medium

  * debian/dmraid2mdadm.cfg: Only append to GRUB_CMDLINE_LINUX_DEFAULT one
    time. (LP: #1465567)

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 16 Jun 2015 10:48:09 +0100

mdadm (3.3-2ubuntu1) utopic; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - debian/initramfs/mdadm-functions: add call wait_for_udev to wait a
      little longer for RAID devices to appear.
    - debian/control: we need udev and util-linux in the right version. We
      also remove the build dependency from quilt and docbook-to-man as both
      are not used in Ubuntus mdadm.
    - debian/initramfs/hook: kept the Ubuntus version for handling the absence
      of active raid arrays in <initramfs>/etc/mdadm/mdadm.conf
    - debian/initramfs/script.local-top.DEBIAN, debian/mdadm-startall,
      debian/mdadm.raid.DEBIAN: removed. udev does its job now instead.
    - debian/mdadm-startall.sgml, debian/mdadm-startall.8: documentation of
      unused startall script
    - debian/mdadm.config, debian/mdadm.postinst - let udev do the handling
      instead. Resolved merge conflict by keeping Ubuntu's version.
    - debian/mkconf.in is the older mkconf. Kept the Ubuntu version.
    - debian/rules: Kept Ubuntus version for installing apport hooks, not
      installing un-used startall script.
    - debian/presubj: Dropped this unused bug reporting file. Instead use
      source_mdadm.py act as an apport hook for bug handling.
    - d/p/debian-changes-3.1.4-1+8efb9d1ubuntu4: mdadm udev rule
      incrementally adds mdadm member when detected. Starting such an
      array in degraded mode is possible by mdadm -IRs. Using mdadm
      -ARs without stopping the array first does nothing when no
      mdarray-unassociated device is available. Using mdadm -IRs to
      start a previously partially assembled array through incremental
      mode. Keeping the mdadm -ARs for assembling arrays which were for
      some reason not assembled through incremental mode (i.e through
      mdadm's udev rule).
    - Take kernel cmdline parameters "nomdmonisw" and "nomdmonddf" into
      account, when assembling imsm/ddf arrays. This defaults to assembling
      those arrays using mdmon/mdadm, with a fallback to dmraid upon
      request.
    - Use default/grub.d snippet to continue using dmraid to assemble
      fakeraid arrays.
  
  * Install incremental assembly rules.
  * Disable use-external-blkid.diff, udev in Ubuntu is recent enough.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 17 Jul 2014 14:49:19 +0100

mdadm (3.3-2) unstable; urgency=low

  * use 63-md-raid-arrays.rules instead of old 64-md-raid.rules
    (Closes: #726237)
  * do not use builtin blkid in udev rules, as our udev (at least
    on wheezy) does not have it (use-external-blkid.diff)

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 14 Oct 2013 15:49:54 +0400

mdadm (3.3-1) unstable; urgency=low

  [ Michael Tokarev ]
  * new upstream 3.3 release (Closes: #718896)
    See ANNOUNCE-3.3 for details.
    Patches:
    - refreshed debian-conffile-location.diff
      (added .conf.d)
    - removed debian-disable-udev-incr-assembly.diff
      (do not ship udev-md-raid-assembly.rules for now)
    - refreshed debian-no-Werror.diff
    - refreshed sha1-includes.diff
    - removed patches (included upstream)A:
       spelling-and-manpages.patch
       fix-enough-function-for-RAID10.patch
       fix-segfaults-in-detail.patch
       super0-do-not-override-uuid-with-homehost.patch
       mdmon-allow-takeover-when-original-was-started-with-.patch
       mdmon-fix-arg-parsing.patch
       mdmon-fix-arg-processing-for-a.path
    Install udev-md-raid-arrays.rules instead of udev-md-raid.rules,
    don't install new udev-md-raid-assembly.rules for now.
  * remove Martin F. Krafft from uploaders per his request.
    Thank you for your contributions!
  * added remove-bashism-from-makefile.patch patch to work around
    newly introduced bashism
  * remove debian/source/options, there's no need to set compression
    options for debian.tar.gz.
  * remove outdated debian/docs/md_superblock_formats.txt and
    debian/docs/md.txt (Closes: #714977, #714978)
  * ship ANNOUNCE-*, external-reshape-design.txt, mdmon-design.txt
    files as documentation (Closes: #715324)

  [ Dmitrijs Ledkovs ]
  * Properly remove 65-mdadm.vol_id.rules, instead of trying to remove a
    never-existed 65_mdadm.vol_id.rules (note the 65- vs 65_).

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 11 Oct 2013 10:12:47 +0400

mdadm (3.2.5-6) unstable; urgency=low

  * replace home-grown and not-working-since-etch udevsettle call
    in initramfs script with proper wait_for_udev function (from
    common initramfs functions).  This unbreaks situations when
    the underlying device needs some udev magic to happen before
    being available, which includes stacked devices (md on lvm)
    and other cases.  Thanks to Thomas Parmelan and Dave Whitla


=== debian/control ===
Source: mdadm
Section: admin
Priority: optional
XSBC-Original-Maintainer: Debian mdadm maintainers <pkg-mdadm-devel@lists.alioth.debian.org>
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Uploaders: Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper (>= 7.4.2), po-debconf, groff-base
Standards-Version: 3.9.3
Vcs-Git: git://git.debian.org/git/pkg-mdadm/mdadm
Vcs-Browser: http://git.debian.org/?p=pkg-mdadm/mdadm.git
Homepage: http://neil.brown.name/blog/mdadm

Package: mdadm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base (>= 3.1-6), debconf (>= 1.4.72), udev (>= 204), initramfs-tools (>= 0.85eubuntu24), util-linux (>= 2.15-1), initscripts (>= 2.88dsf-13.3)
Recommends: kmod | module-init-tools
Suggests: default-mta | mail-transport-agent
Replaces: mdctl
Breaks: udev (<< 136-1), mdctl (<< 0.7.2), raidtools2 (<< 1.00.3-12.1), dmraid (<= 1.0.0.rc16-4.2ubuntu1)
Description: tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This package automatically configures mdadm to assemble arrays during the
 system startup process. If not needed, this functionality can be disabled.

Package: mdadm-udeb
Section: debian-installer
XC-Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}
Description: tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This is a minimal package used by the debian-installer.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright © 2001-2005 Mario Jou/3en <joussen@debian.org>
# Copyright © 2005-2008 Martin F. Krafft <madduck@debian.org>
# Distributable under the terms of the GNU GPL version 2.
#

#export DH_VERBOSE=1

CXFLAGS = -ggdb
CXFLAGS_UDEB := $(CXFLAGS) -fomit-frame-pointer
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    CXFLAGS += -O0
    CXFLAGS_UDEB += -O0
else
    CXFLAGS += -O2
    CXFLAGS_UDEB += -Os
endif

.PHONY: configure
configure:

build: configure build-stamp
build-stamp:
	dh_testdir
	$(MAKE) -f debian/rules mdadm.udeb DEBIAN=yes
	$(MAKE) clean
	$(MAKE) -f debian/rules mdadm DEBIAN=yes
	touch $@

mdadm.udeb: FLAGS = CXFLAGS="$(CXFLAGS_UDEB)" CONFFILE=/tmp/mdadm.conf
mdadm.udeb: configure
	dh_testdir
	$(MAKE) $(FLAGS) all
	mv mdadm mdadm.udeb
	mv mdmon mdmon.udeb
.PHONY: mdadm.udeb mdmon.udeb

mdadm: FLAGS = CXFLAGS="$(CXFLAGS)" CONFFILE=/etc/mdadm/mdadm.conf CONFFILE2=/etc/mdadm.conf
mdadm: configure
	dh_testdir
	$(MAKE) $(FLAGS) all
.PHONY: mdadm

INTERPOLATED_FILES = debian/bugscript debian/mkconf

clean:
	dh_testdir
	rm -f $(INTERPOLATED_FILES)
	rm -f build-stamp
	[ ! -f Makefile ] || $(MAKE) clean
	rm -f mdadm.udeb mdmon.udeb mdadm debian/mdadm-startall.8
	dh_clean
	debconf-updatepo

debian/%: VERSION=$(shell dpkg-parsechangelog | sed -ne 's,^Version: ,,p')
debian/%: debian/%.in
	sed -re 's,%VERSION%,$(VERSION),g' < $< > $@

install: DESTDIR=$(CURDIR)/debian/mdadm
install: DESTDIR_UDEB=$(DESTDIR)-udeb
install: build $(INTERPOLATED_FILES)
	dh_testdir
	dh_clean -k
	dh_installdirs

	$(MAKE) install DESTDIR=$(DESTDIR)

	install -m0755 debian/initramfs/hook \
		$(DESTDIR)/usr/share/initramfs-tools/hooks/mdadm

	install -m0755 debian/initramfs/init-premount \
		$(DESTDIR)/usr/share/initramfs-tools/scripts/init-premount/mdadm

	install -m0755 debian/initramfs/mdadm-functions \
		$(DESTDIR)/usr/share/initramfs-tools/scripts/mdadm-functions

	install -m0755 debian/mkconf $(DESTDIR)/usr/share/mdadm
	install -m0755 debian/checkarray $(DESTDIR)/usr/share/mdadm
	install -m0755 debian/bugscript $(DESTDIR)/usr/share/bug/mdadm/script
	install -m0644 debian/source_mdadm.py $(DESTDIR)/usr/share/apport/package-hooks/
	install -m0755 mdadm.udeb $(DESTDIR_UDEB)/sbin/mdadm
	install -m0755 mdmon.udeb $(DESTDIR_UDEB)/sbin/mdmon
	install -m0644 udev-md-raid-arrays.rules $(DESTDIR_UDEB)/lib/udev/rules.d/63-md-raid-arrays.rules
	install -m0644 udev-md-raid-assembly.rules $(DESTDIR_UDEB)/lib/udev/rules.d/64-md-raid-assembly.rules

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_lintian
	dh_installdebconf
	dh_installdocs
	dh_installexamples debian/mdadd.sh
	dh_installinit -- defaults 25
	dh_installinit --init-script=mdadm-waitidle --no-start -- stop 98 0 6 .
	dh_installman
	dh_installcron
	dh_installchangelogs ChangeLog
	dh_installlogcheck
	dh_link
	dh_strip
	dh_compress -Xmdadd.sh
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
build-indep:
build-arch: build
.PHONY: build build-indep build-arch clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=3
http://www.kernel.org/pub/linux/utils/raid/mdadm/mdadm-([.[:digit:]]+).tar.gz

## mdadm 3.3.2

=== debian/changelog ===
mdadm (3.3.2-5) unstable; urgency=medium

  * use-tempnode-not-devnode.patch: change udev rules file to use
    $tempnode which works both on wheezy and jessie udev, instead
    of $devnode which only works in jessie.  At this stage it is
    better to make rules file compatible with old version instead
    of adding versioned dependency.  Should be removed for jessie+1.
    (Closes: #770883)
  * fix Closes: list in previous entry (Closes: #771852)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 20 Dec 2014 11:48:44 +0300

mdadm (3.3.2-4) unstable; urgency=medium

  * really remove /var/lib/mdadm in postinst, fixing a brown-paper bag
    bug in previous upload (I fixed it earlier but forgot to commit it
    before 3.3.2-3 release).  (Closes: #764036, #771852)
  * mention closing of #588965 #599352 #694513 by 3.3-1

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 05 Dec 2014 17:29:22 +0300

mdadm (3.3.2-3) unstable; urgency=medium

  * remove /var/lib/mdadm dir in postinst to clean up from old pkg,
    remove config files on purge (restore extraneous cleanup from
    last change)  (Closes: #764036)
  * remove set -u (error on unset variables) from maintscripts
    (Closes: #766308)
  * rebuildmap-strip-local-host-name-from-device-name.patch - a patch
    from upstream fixing a bug when mdadm have to re-create device
    nodes after assembling arrays (eg, when switching from initramfs
    without preserving /dev and /run), to choose the same device names
    as when doing inital assembly
  * readlink-path.patch: readlink is in /bin not /usr/bin on debian
    (Closes: #766416)
  * mdmonitor-service-simplify.diff: simplify mdmonitor.service
    systemd file, do not try to read non-existing files (Closes: #764647)

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 28 Nov 2014 09:55:14 +0300

mdadm (3.3.2-2) unstable; urgency=medium

  * remove more leftovers from old versions
  * do not embed $VERSION to mkconf and bugscript
  * removed unneeded lintian-overrides file
  * removed examples/mdadd.sh
  * removed references to MAIL_TO from /etc/default/mdadm (pre-2.x mdadm)
  * removed AUTOSTART variable from /etc/default/mdadm
    (system will start arrays listed in mdadm.conf)
  * simplify d/rules, build udeb in a subdir (for now, to be removed)
  * install systemd services and disable some initscripts (mask them)
    when systemd is running (Closes: #763959)
  * build-sys-no-check_rundir.patch: stop (re)linking executables
    at install time

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 04 Oct 2014 20:38:36 +0400

mdadm (3.3.2-1) unstable; urgency=low

  * new minor/bugfix upstream release (Closes: #731884, #763080)
  * removed remove-bashism-from-makefile.patch (applied upstream)
  * copy 64-md-raid-assembly.rules to initramfs too, this should
    bring us array auto-assemble during initramfs run (Closes: #678691)
  * denote inability to initialize md subsystem in local-top script
    from fatal error to warning (Closes: #733574)
  * create /etc/modprobe.d/mdadm.conf to set start_ro=1 there
    instead of doing it in the initramfs
  * use install -D in d/rules consistently and remove dirs from d/mdadm.dirs
  * remove references to old (2.x and 1.x) mdadm versions (Closes: #728804)
  * remove references to very old (pre-wheeze) breaks/replaces/depends
  * remove support of makedev
  * reformat mdadm-raid initscript a bit
  * remove rebuilding-raid.html (had invisible refs) and
    RAID5_versus_RAID10.txt docs.  Maybe it's a good idea to remove
    other docs shipped with the package, since these becoming stale
    and these days, better alternatives exist online
  * removed debian-specific mdadm-startall script which does nothing more than
    "mdadm --assemble --scan".  Remove docbook-to-man from build-deps.
  * pass dpkg-buildflags to upstream build system and
    stop using our own -O0, -Os etc
  * remove separate CFLAGS for udeb and simplify *FLAGS handling
  * bump Standards-Version to 3.9.5 (no changes needed)
  * fix VCS links to point to anonscm.d.o

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 01 Oct 2014 15:09:07 +0400

=== debian/control ===
Source: mdadm
Section: admin
Priority: optional
Maintainer: Debian mdadm maintainers <pkg-mdadm-devel@lists.alioth.debian.org>
Uploaders: Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper (>= 6.0.7~), po-debconf, groff-base
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/pkg-mdadm/mdadm.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-mdadm/mdadm.git
Homepage: http://neil.brown.name/blog/mdadm

Package: mdadm
Architecture: any
Depends: ${shlibs:Depends}, udev, ${misc:Depends}, lsb-base, debconf, initscripts
Recommends: default-mta | mail-transport-agent, kmod | module-init-tools
Description: tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This package automatically configures mdadm to assemble arrays during the
 system startup process. If not needed, this functionality can be disabled.

Package: mdadm-udeb
Section: debian-installer
XC-Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}
Description: tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This is a minimal package used by the debian-installer.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright © 2001-2005 Mario Jou/3en <joussen@debian.org>
# Copyright © 2005-2008 Martin F. Krafft <madduck@debian.org>
# Distributable under the terms of the GNU GPL version 2.
#

#export DH_VERBOSE=1

LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
CXFLAGS = $(shell dpkg-buildflags --get CFLAGS) \
	  $(shell dpkg-buildflags --get CPPFLAGS)
BUILDFLAGS = CXFLAGS="$(CXFLAGS)" LDFLAGS="$(LDFLAGS)" DEBIAN=yes
DESTDIR = $(CURDIR)/debian/mdadm
DESTDIR_UDEB = $(DESTDIR)-udeb

build-arch: build-stamp

build-stamp:
	dh_testdir
	$(MAKE) all $(BUILDFLAGS) CONFFILE=/etc/mdadm/mdadm.conf CONFFILE2=/etc/mdadm.conf
	touch $@

# udeb rules should go, the only diff is the conffile location,
# and d-i specifies path explicitly when needed

udeb/dir-stamp:
	rm -rf udeb
	mkdir udeb
	ln *.[ch] Makefile udeb/
	touch $@

build-arch: udeb/build-stamp

udeb/build-stamp: udeb/dir-stamp
	dh_testdir
	$(MAKE) -C udeb mdadm mdmon $(BUILDFLAGS) CONFFILE=/tmp/mdadm.conf
	touch $@

clean:
	dh_testdir
	rm -f build-stamp
	$(MAKE) clean
	rm -rf udeb
	dh_clean

install-arch: build-arch
	dh_testdir
	dh_clean -k
	dh_installdirs

	$(MAKE) install install-systemd DESTDIR=$(DESTDIR)

	mkdir -p $(DESTDIR)/etc/mdadm
	install -Dm0755 debian/initramfs/hook \
		$(DESTDIR)/usr/share/initramfs-tools/hooks/mdadm
	install -Dm0755 debian/initramfs/script.local-top \
		$(DESTDIR)/usr/share/initramfs-tools/scripts/local-top/mdadm
	install -Dm0644 debian/mdadm.modules \
		$(DESTDIR)/etc/modprobe.d/mdadm.conf

	install -Dm0755 debian/mkconf $(DESTDIR)/usr/share/mdadm/mkconf
	install -Dm0755 debian/checkarray $(DESTDIR)/usr/share/mdadm/checkarray
	install -Dm0755 debian/bugscript $(DESTDIR)/usr/share/bug/mdadm/script
	install -Dm0644 debian/presubj $(DESTDIR)/usr/share/bug/mdadm/presubj

	install -Dm0755 udeb/mdadm $(DESTDIR_UDEB)/sbin/mdadm
	install -Dm0755 udeb/mdmon $(DESTDIR_UDEB)/sbin/mdmon
	install -Dm0644 udev-md-raid-arrays.rules $(DESTDIR_UDEB)/lib/udev/rules.d/63-md-raid-arrays.rules

binary-arch: install-arch
	dh_testdir
	dh_testroot
	dh_installdebconf
	dh_installdocs
	dh_installexamples -pmdadm mdadm.conf-example misc/syslog-events
	dh_installinit --init-script=mdadm-raid --no-restart-on-upgrade -- start 25 S . start 60 0 6 .
	dh_installinit --init-script=mdadm-waitidle --no-start -- stop 98 0 6 .
	dh_link -pmdadm /dev/null /lib/systemd/system/mdadm-waitidle.service
	dh_installinit -- defaults 25
	dh_link -pmdadm /dev/null /lib/systemd/system/mdadm.service
	dh_installman
	dh_installcron
	dh_installchangelogs ChangeLog
	dh_installlogcheck
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

build: build-arch
install: install-arch
binary: binary-arch
build-indep:
install-indep:
binary-indep:
.PHONY: clean build build-indep build-arch binary binary-indep binary-arch install install-indep install-arch

## mdadm 3.3.4

=== debian/changelog ===
mdadm (3.3.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * disable-incremental-assembly.patch: incremental assembly prevents booting
    in degraded mode (Closes: #784070)

 -- Yann Soubeyrand <yann-externe.soubeyrand@edf.fr>  Tue, 10 Nov 2015 11:18:39 +0100

mdadm (3.3.4-1) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Adopting the package as per mjt delegation. Thank you for your
    service mainting this package over the years, your contributions
    are highly appreciated by all of Debian and derivate communities.
  * New upstream release.
  * Bump standards version to 3.9.6.0, no changes required.
  * Use dh_prep instead of dh_clean -k
  * Drop cherrypicked patches.

  [ Helmut Grohne ]
  * Fix FTCBFS. Export CROSS_COMPILE=<triplet>- (Closes: #794335)

  [ Cyril B. ]
  * Copy AUTO lines from host into initrd, when updating initrd.
    (Closes: #785104)

  [ Martin von Wittich ]
  * Ignore errors attempting to apply *nice to checkarray, it may be
    done already. (Closes: #791554)

 -- Dimitri John Ledkov <xnox@debian.org>  Sun, 08 Nov 2015 11:48:03 +0000

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: admin
 Priority: optional
 Maintainer: Debian mdadm maintainers <pkg-mdadm-devel@lists.alioth.debian.org>
-Uploaders: Michael Tokarev <mjt@tls.msk.ru>
+Uploaders: Dimitri John Ledkov <xnox@debian.org>
 Build-Depends: debhelper (>= 6.0.7~), po-debconf, groff-base
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Git: git://anonscm.debian.org/pkg-mdadm/mdadm.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-mdadm/mdadm.git
 Homepage: http://neil.brown.name/blog/mdadm

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,7 @@
 
 #export DH_VERBOSE=1
 
+export CROSS_COMPILE=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)-
 LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
 CXFLAGS = $(shell dpkg-buildflags --get CFLAGS) \
 	  $(shell dpkg-buildflags --get CPPFLAGS)
@@ -45,7 +46,7 @@
 
 install-arch: build-arch
 	dh_testdir
-	dh_clean -k
+	dh_prep
 	dh_installdirs
 
 	$(MAKE) install install-systemd DESTDIR=$(DESTDIR)

## mdadm 3.4

=== debian/changelog ===
mdadm (3.4-4ubuntu0.1) zesty; urgency=medium

  * Ship mdadm-shutdown.service and suggest dracut-core. Users of systemd
    with rootfs on Intel Matrix Raid and DDF external metadata-raid arrays
    that require mdmon monitoring, may wish to install dracut-core package
    and enable mdadm-shutdown.service. This will create a shutdown
    initramfs, that systemd-shutdown can pivot to. This may result in an
    improved shutdown behaviour with less hangs and synced raid
    arrays. The generated initramfs will takeover mdmon monitoring, wait
    for the arrays to be clean before stopping them and unmounting
    everything and finally executing requested shutdown command.
    LP: #1722491

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 13 Oct 2017 18:31:49 +0100

mdadm (3.4-4) unstable; urgency=high

  * Bring in changes from Ubuntu, to make the two packages in sync:
    - Drop README.Debian, quite out-of-date w.r.t. current packaging.
    - debian/control - on ubuntu, downgrade default-mta from Recommends to
    Suggests.
    - update-grub in postinst, if available (note does not update grub1).
    - drop stderr warnings in postrm.
    - drop presubj, out of date, and all types of bugs are welcomed.
    - on ubuntu, install apport package hook.
    - on ubuntu, install incremental assembly udev rules into udeb.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 28 Jul 2016 16:52:07 +0100

mdadm (3.4-3) unstable; urgency=high

  * Fix UUID= grep for configured RAIDs to be case incesetive, regression from 3.4-2.

  * Re-trigger block devices at the start of local-block mdadm loop, to
    re-incrementally assemble disks that appeared before RAID
    personalities were registered with the kernel.

  * Also, invoke non-incremental assembly of raid arrays in the
    local-block loop to support running mdadm with user-exported variables
    specified via param.conf.

  * Set Vcs- fields to dgit repositories.

  * Closes: #830770, #830300.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 26 Jul 2016 17:09:54 +0100

mdadm (3.4-2) unstable; urgency=low

  * Reneable incremental assembly
  * Rely on udev to assemble incremental arrays
  * In environments with systemd rely on mdadm-last-resort@.timer|.service
    units to activate degrated raids
  * In environments initramfs-tools initrd (no systemd) add local-block
    script to do the same after 2/3rds of root delay iteration
  * Drop local-top initramfs script
  * Drop dependency on initscripts package
  * Drop INITRDSTART support
  * Drop mdadm-raid init script
  * Drop ancient preinst
  * In mdadm.init remove dependency on mdadm-raid
  * In mdadm.init check, and bail out running in a container
  * In mdadm.config drop mdadm/autostart logic
  * Drop CREATE stanzas from mkconf and don't include them in the
    initramfs. The generated defaults, are the compiled-in defaults. And
    the current one generates warnings when running mdadm in the
    initramfs, as there is no passwd|group files to resolve root/disk
    uid/gid. Closes: 717609
  * Adapt changes and formatting of initramfs hook from Ubuntu
  * Bump standards version to 3.9.7, no changes required
  * Fix copyright-refers-to-symlink-license
  * Closes: #781172, #796624, #769201, #813335, #632401, #804973, #714155,
    #770002, #737132, #675452, #726390, #813637, #814036.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sat, 02 Jul 2016 19:16:01 +0100

mdadm (3.4-1) unstable; urgency=medium

  * New upstream release.
  * Drop use-tempnode-not-devnode.patch, not needed anymore.
  * Drop use-external-blkid.diff. (Closes: #793631)
  * Refresh patches.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 19 Feb 2016 16:18:36 +0000

=== debian/control ===
Source: mdadm
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian mdadm maintainers <pkg-mdadm-devel@lists.alioth.debian.org>
Uploaders: Dimitri John Ledkov <xnox@debian.org>
Build-Depends: debhelper (>= 6.0.7~), po-debconf, groff-base
Standards-Version: 3.9.7
Vcs-Git: https://git.dgit.debian.org/mdadm
Vcs-Browser: https://browse.dgit.debian.org/mdadm.git
Homepage: http://neil.brown.name/blog/mdadm

Package: mdadm
Architecture: linux-any
Depends: ${shlibs:Depends}, udev, ${misc:Depends}, lsb-base, debconf
Recommends: ${mta:Recommends}, kmod | module-init-tools
Suggests: ${mta:Suggests}, dracut-core
Description: tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This package automatically configures mdadm to assemble arrays during the
 system startup process. If not needed, this functionality can be disabled.

Package: mdadm-udeb
Section: debian-installer
XC-Package-Type: udeb
Architecture: linux-any
Depends: ${shlibs:Depends}
Description: tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This is a minimal package used by the debian-installer.

## mdadm 4.0

=== debian/changelog ===
mdadm (4.0-2ubuntu1) bionic; urgency=medium

  * Cherry-pick upstream patch to ensure mdadm-last-resort services
    only runs when it is needed LP: #1753786
    - debian/patches/mdadm-last-resort-use-condition-path-exists.patch

 -- Ryan Harper <ryan.harper@canonical.com>  Wed, 07 Mar 2018 01:43:16 -0600

mdadm (4.0-2) unstable; urgency=medium

  * Ship mdadm-shutdown.service and suggest dracut-core. Users of systemd
    with rootfs on Intel Matrix Raid and DDF external metadata-raid arrays
    that require mdmon monitoring, may wish to install dracut-core package
    and enable mdadm-shutdown.service. This will create a shutdown
    initramfs, that systemd-shutdown can pivot to. This may result in an
    improved shutdown behaviour with less hangs and synced raid
    arrays. The generated initramfs will takeover mdmon monitoring, wait
    for the arrays to be clean before stopping them and unmounting
    everything and finally executing requested shutdown command.
  * Bump standards version, no changes required.
  * Bump debhelper to 9.
  * Add second email address to avoid NMU warnings.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 10 Oct 2017 11:55:52 +0100

mdadm (4.0-1) unstable; urgency=medium

  * New upstream release. LP: #1668128
  * Drop warnings that raid arrays are missing from the initramfs
    configuration. Instead have a positive message as to which arrays are
    included in the initramfs.
  * Add a warning to mkconf generated file that mdadm.conf is copied into
    initrafms.
  * Fix checkarray script bugs. LP: #1599428 Closes: #787950 Closes: #843665

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 22 Jun 2017 13:23:10 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian mdadm maintainers <pkg-mdadm-devel@lists.alioth.debian.org>
-Uploaders: Dimitri John Ledkov <xnox@debian.org>
-Build-Depends: debhelper (>= 6.0.7~), po-debconf, groff-base
-Standards-Version: 3.9.7
+Uploaders: Dimitri John Ledkov <xnox@debian.org>, Dimitri John Ledkov <xnox@ubuntu.com>
+Build-Depends: debhelper (>= 9), po-debconf, groff-base
+Standards-Version: 4.1.1
 Vcs-Git: https://git.dgit.debian.org/mdadm
 Vcs-Browser: https://browse.dgit.debian.org/mdadm.git
 Homepage: http://neil.brown.name/blog/mdadm

=== debian/rules ===
--- 
+++ 
@@ -54,19 +54,24 @@
 	mkdir -p $(DESTDIR)/etc/mdadm
 	install -Dm0755 debian/initramfs/hook \
 		$(DESTDIR)/usr/share/initramfs-tools/hooks/mdadm
-	install -Dm0755 debian/initramfs/script.local-top \
-		$(DESTDIR)/usr/share/initramfs-tools/scripts/local-top/mdadm
+	install -Dm0755 debian/initramfs/script.local-block \
+		$(DESTDIR)/usr/share/initramfs-tools/scripts/local-block/mdadm
+	install -Dm0755 debian/initramfs/script.local-bottom \
+		$(DESTDIR)/usr/share/initramfs-tools/scripts/local-bottom/mdadm
 	install -Dm0644 debian/mdadm.modules \
 		$(DESTDIR)/etc/modprobe.d/mdadm.conf
 
 	install -Dm0755 debian/mkconf $(DESTDIR)/usr/share/mdadm/mkconf
 	install -Dm0755 debian/checkarray $(DESTDIR)/usr/share/mdadm/checkarray
 	install -Dm0755 debian/bugscript $(DESTDIR)/usr/share/bug/mdadm/script
-	install -Dm0644 debian/presubj $(DESTDIR)/usr/share/bug/mdadm/presubj
-
 	install -Dm0755 udeb/mdadm $(DESTDIR_UDEB)/sbin/mdadm
 	install -Dm0755 udeb/mdmon $(DESTDIR_UDEB)/sbin/mdmon
 	install -Dm0644 udev-md-raid-arrays.rules $(DESTDIR_UDEB)/lib/udev/rules.d/63-md-raid-arrays.rules
+	install -Dm0644 debian/mdadm-shutdown.service $(DESTDIR)/lib/systemd/system/mdadm-shutdown.service
+ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes), yes)
+	install -Dm0644 udev-md-raid-assembly.rules $(DESTDIR_UDEB)/lib/udev/rules.d/64-md-raid-assembly.rules
+	install -Dm0644 debian/source_mdadm.py $(DESTDIR)/usr/share/apport/package-hooks/source_mdadm.py
+endif
 
 binary-arch: install-arch
 	dh_testdir
@@ -74,7 +79,6 @@
 	dh_installdebconf
 	dh_installdocs
 	dh_installexamples -pmdadm mdadm.conf-example misc/syslog-events
-	dh_installinit --init-script=mdadm-raid --no-restart-on-upgrade -- start 25 S . start 60 0 6 .
 	dh_installinit --init-script=mdadm-waitidle --no-start -- stop 98 0 6 .
 	dh_link -pmdadm /dev/null /lib/systemd/system/mdadm-waitidle.service
 	dh_installinit -- defaults 25
@@ -89,7 +93,11 @@
 	dh_fixperms
 	dh_installdeb
 	dh_shlibdeps
-	dh_gencontrol
+ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes), yes)
+	dh_gencontrol -- -Vmta:Suggests="default-mta | mail-transport-agent"
+else
+	dh_gencontrol -- -Vmta:Recommends="default-mta | mail-transport-agent"
+endif
 	dh_md5sums
 	dh_builddeb

## mdadm 4.1~rc1

=== debian/changelog ===
mdadm (4.1~rc1-4ubuntu1) cosmic; urgency=medium

  * Ship finalrd hook.
  * Do not install mdadm-shutdown.service on Ubuntu.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 03 Aug 2018 14:53:18 +0100

mdadm (4.1~rc1-4) unstable; urgency=medium

  * Cherrypick master patches up to 20th of July 2018. LP: #1781427
  * Make safe-timouts udev rules compatible with usr-split systems.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Jul 2018 11:48:50 +0100

mdadm (4.1~rc1-3) unstable; urgency=medium

  * Cherrypick master patches up to 4th of June 2018.

 -- Dimitri John Ledkov 🌈 <xnox@ubuntu.com>  Tue, 26 Jun 2018 15:38:04 +0100

mdadm (4.1~rc1-2) unstable; urgency=medium

  * Install identical udev rules into d-i installer udeb, as used in the
    installed system. Specifically, post-processed rules with full path to
    mdadm binary subsituted, instead of installing useless rules with the
    template variable BINDIR. LP: #1705215

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 22 May 2018 14:26:59 +0100

mdadm (4.1~rc1-1) unstable; urgency=medium

  * New upstream release.
  * Import patches since rc1.
  * Bump standards version & debhelper compat.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 15 May 2018 12:10:33 +0100

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian mdadm maintainers <pkg-mdadm-devel@lists.alioth.debian.org>
 Uploaders: Dimitri John Ledkov <xnox@debian.org>, Dimitri John Ledkov <xnox@ubuntu.com>
-Build-Depends: debhelper (>= 9), po-debconf, groff-base
-Standards-Version: 4.1.1
+Build-Depends: debhelper (>= 11), po-debconf, groff-base
+Standards-Version: 4.1.4
 Vcs-Git: https://git.dgit.debian.org/mdadm
 Vcs-Browser: https://browse.dgit.debian.org/mdadm.git
 Homepage: http://neil.brown.name/blog/mdadm
@@ -13,7 +13,9 @@
 Package: mdadm
 Architecture: linux-any
 Depends: ${shlibs:Depends}, udev, ${misc:Depends}, lsb-base, debconf
-Recommends: ${mta:Recommends}, kmod | module-init-tools
+Recommends: ${mta:Recommends}, kmod | module-init-tools, finalrd (>= 3~)
+Breaks: finalrd (<= 2)
+Replaces: finalrd (<= 2)
 Suggests: ${mta:Suggests}, dracut-core
 Description: tool to administer Linux MD arrays (software RAID)
  The mdadm utility can be used to create, manage, and monitor MD
